﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SingleWave : MonoBehaviour {

    private float waveLength = 1.0f;
    private float waveHeight = 2.0f;

    public SingleWave nextWave;

    private Vector3 InitialPosition = new Vector3();

    private bool insideWave = false;

    private Animator parentAnimator;

	// Use this for initialization
	void Start () {
        InitialPosition = transform.parent.position;
        parentAnimator = transform.parent.GetComponent<Animator>();
	}

    public void InitWave(float waveTime, float waveHeight, float nextWaveTime)
    {
        if (insideWave)
        {
            return;
        }
        waveLength = waveTime;
        this.waveHeight = waveHeight;
        StartCoroutine(Wave());
        StartCoroutine(StartNextWave(nextWaveTime));
    }

    IEnumerator Wave()
    {
        if (parentAnimator != null)
        {
            //parentAnimator.Stop();
            parentAnimator.SetBool("playing", false);
        }
        insideWave = true;
        Vector3 newPosition = new Vector3(0, 0, 0);
        float time = 0f;
        while (time < 1f)
        {
            newPosition.y = Mathf.Sin((time * 360) * Mathf.Deg2Rad) * waveHeight;
            this.transform.parent.position = InitialPosition + newPosition;
            time += Time.deltaTime / waveLength;
            yield return null;
        }
        insideWave = false;
        if (parentAnimator != null)
        {
            //parentAnimator.Play("SeaElementAnim", 0, Random.value);
            Debug.Log("Restaurando animación");
            //parentAnimator.StartPlayback();
            parentAnimator.Play("SeaElementAnim", 0, Random.value);
            parentAnimator.SetBool("playing", true);

        }
    }

    IEnumerator StartNextWave(float waitTime)
    {
        yield return new WaitForSeconds(waitTime);
        if (nextWave != null)
        {
            //Animator anim = nextWave.transform.parent.GetComponent<Animator>();
            //if (anim != null)
            //{
            //    anim.SetBool("playing",false);
            //}
            nextWave.InitWave(waveLength, waveHeight, waitTime);
        }
    }
}
